import math

error = 1e-4/3

# Weierstrass function f(x) - x
def mWeierstrass(x, a, b):

    # Setup first term of the sum in definition of weierstrass function
    y = math.pi*x
    t = 1
    v = t*math.cos(y)
    s = v

    # Keep adding terms until absolute of residual terms is smaller than error
    while t > error*(1 - a):
        y *= b
        t *= a
        v = t*math.cos(y)
        s += v
    return s - x

# Another way of computing the weierstrass function.
def mWeierstrass2(x, a, b):
    y = math.pi*x
    t = 1
    v = t*math.cos(y)
    s = v
    while t > error*(1 - a):
        y *= b
        t *= a
        v = t*math.cos(y%(2 * math.pi))
        s += v
    return s - x

a, b = map(float, input().split())

# Setup boundaries of box under consideration
left = 0
right = 1

# Iterate shrinking the box until we find a fixed point
while True:
    mid = (left + right)/2
    fm = mWeierstrass(mid, a, b) # Evaluate function
    # Update boundaries
    if fm < 0:
        right = mid
        fr = fm
    elif fm > 0:
        left = mid
        fl = fm
    # Detect fixed point
    if abs(fm) < error:
        print(mid)
        break


