import heapq # efficient priority queue

k = int(input())

primes = []

# precompute sufficiently many primes
for p in range(2, 2000):
  prim = True
  for d in range(2, int(p ** 0.5) + 1):
    if p % d == 0:
      prim = False
      break
  if prim:
    primes.append(p)

# keep track of squareful numbers
sqfls = [False] * 2000000

# start with n=1 and the 0th prime
q = [[1,0]]

# traverse priority queue and iteratively pop n
while len(q) > 0:
  n, p = heapq.heappop(q)
  sqfls[n] = True
  # check if n-k was squareful
  if n > k and sqfls[n-k]:
    # if so, a solution was found
    print(n-k)
    break
  prim = primes[p]
  # either move on to the next prime,
  if p < len(primes) - 1:
    heapq.heappush(q, [n, p + 1])
  # or keep adding the current prime factor
  if n % prim == 0:
    if n * prim < 2000000:
      heapq.heappush(q, [n * prim, p])
  else:
    # if prim does not yet divide n, multiply by
    # prim * prim to keep squarefulness of n
    if n * prim * prim < 2000000:
      heapq.heappush(q, [n * prim * prim, p])
