from collections import deque # efficient queue

MOD = 1000000007

# read and store input
n = int(input())
k = int(input())
nbrs = []
for i in range(n):
  nbrs.append([])
for i in range(k):
  a, b = [int(i) - 1 for i in input().split()]
  nbrs[a].append(b)
  nbrs[b].append(a)

# find connected components through BFS
# store which vertices were visited
visited = [False] * n
seen = 0
conncount = 0
fstunseen = 0
# keep a running total
res = 1
q = deque()

# continue until each vertex was visited
while seen < n:
  # reset size of current connected component
  conncount = 0
  # find next unvisited vertex
  while visited[fstunseen]:
    fstunseen += 1
  # append unvisited vertex to queue; we
  # will find its connected component
  q.append(fstunseen)
  
  # iteratively visit all neighbours through BFS
  while len(q) > 0:
    nxt = q.popleft()
    if visited[nxt]:
      continue
    # for each yet unvisited vertex, contribute
    # to the size of the current connected component
    seen += 1
    conncount += 1
    # instead of taking conncount! at the end, multiply
    # only by each factor (1, 2, etc) during each step
    res *= conncount
    res %= MOD
    visited[nxt] = True
    # add all neighbours to the queue to visit as well
    for i in nbrs[nxt]:
      if not visited[i]:
        q.append(i)
        
# output the result
print(res)
